# -*- coding: utf-8 -*-

#Copyright 2009 tv-player team <tvplayer.staff@gmail.com>
#       
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU Lesser General Public License as published by
#the Free Software Foundation; version 3 of the License.
#       
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU Lesser General Public License for more details.
#       
#You should have received a copy of the GNU Lesser General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#MA 02110-1301, USA.

import gtk
import pygtk
import os
import urllib

import gettext


_ = gettext.gettext

###aggiunge link dell'utente

class Add() :

    def __init__(self,nationlist):
        builder = gtk.Builder()
        builder.set_translation_domain('tvplayer')
        builder.add_from_file("ui/add-ui.xml") 
        builder.connect_signals(self)
        self.window_add = builder.get_object("window_add")
        self.link_entry = builder.get_object("link_entry")
        self.nome_entry = builder.get_object("nome_entry")
        self.annulla_button = builder.get_object("annulla_button")
        self.aggiungi_button = builder.get_object("aggiungi_button")
        self.combobox1 = builder.get_object("combobox1")
        self.combobox2 = builder.get_object("combobox2")

        home = os.path.expanduser('~')
        self.config_dir = home +'/.tvplayer'
        
        ####riempie combobox1
        self.liststore = gtk.ListStore(str)
        self.cell = gtk.CellRendererText()
        self.combobox1.pack_start(self.cell)
        self.combobox1.set_attributes(self.cell, text=0)
        
        self.liststore.append([_("TV")])
        self.liststore.append([_("RADIO")])
        self.combobox1.set_model(self.liststore)
        self.combobox1.set_active(0)
        ######
        
        ####riempie combobox2
        self.liststore2 = gtk.ListStore(str)
        self.cell2 = gtk.CellRendererText()
        self.combobox2.pack_start(self.cell2)
        self.combobox2.set_attributes(self.cell2, text=0)
        
        for i in nationlist:
			if i!="ALL":
			    self.liststore2.append([i])

        self.combobox2.set_model(self.liststore2)
        self.combobox2.set_active(0)
        ######

        self.window_add.show()

    def aggiungi(self,nome_entry):
        print self.nome_entry.get_text()
        print self.link_entry.get_text()
        if self.combobox1.get_active()==0:
            type = "tv"
        else:
            type = "radio"
        file=open(os.path.expanduser(self.config_dir + '/personal_'+type+'.list'), 'a')
        file.write(self.nome_entry.get_text()+" #"+self.link_entry.get_text()+" #"+self.combobox2.get_active_text()+"\n")
        file.close()
        self.window_add.hide()
        gtk.main_quit()

    def annulla(self,window_add):
        self.window_add.hide()
        gtk.main_quit()
 
    def main(self):
        gtk.main()


class AddDatabase() :
    
    def __init__(self, lista, nationlist):
        builder = gtk.Builder()
        builder.set_translation_domain('tvplayer')
        builder.add_from_file("ui/addDatabase-ui.xml") 
        builder.connect_signals(self)
        self.window_Data = builder.get_object("window_Data")
        self.treeview1 = builder.get_object("treeview1")
        self.combobox1 = builder.get_object("combobox1")
        self.combobox2 = builder.get_object("combobox2")
        self.button_add = builder.get_object("button_add")
        self.button_cancel = builder.get_object("button_cancel")
        
        self.lista=lista
        
        ###treeview Database
        self.model = gtk.ListStore(str,str,str,str)
        self.treeview1.set_model(self.model)

        self.treecol1 = gtk.TreeViewColumn(_("DATABASE List"))
        self.cellrenderer1 = gtk.CellRendererText()
        self.treecol1.pack_start(self.cellrenderer1, False)
        self.treecol1.set_attributes(self.cellrenderer1, text = 0)
        self.treeview1.append_column(self.treecol1)
        
        self.treecol2 = gtk.TreeViewColumn(_("Type"))
        self.cellrenderer2 = gtk.CellRendererText()
        self.treecol2.pack_start(self.cellrenderer2, False)
        self.treecol2.set_attributes(self.cellrenderer2, text = 1)
        self.treeview1.append_column(self.treecol2)
        
        self.treecol3 = gtk.TreeViewColumn(_("Language"))
        self.cellrenderer3 = gtk.CellRendererText()
        self.treecol3.pack_start(self.cellrenderer3, False)
        self.treecol3.set_attributes(self.cellrenderer3, text = 2)
        self.treeview1.append_column(self.treecol3)
        
        self.treecol4 = gtk.TreeViewColumn(_("Link"))
        self.cellrenderer4 = gtk.CellRendererText()
        self.treecol4.pack_start(self.cellrenderer4, False)
        self.treecol4.set_attributes(self.cellrenderer4, text = 3)
        self.treeview1.append_column(self.treecol4)
        
        self.treeselection = self.treeview1.get_selection()
        self.treeselection.set_mode(gtk.SELECTION_MULTIPLE)
		###
		
        ###liststore del combobox1
        self.liststore = gtk.ListStore(str)
        self.cell = gtk.CellRendererText()
        self.combobox1.pack_start(self.cell)
        self.combobox1.set_attributes(self.cell, text=0)
        
        self.liststore.append([_("BOTH")])
        self.liststore.append([_("TV ONLY")])
        self.liststore.append([_("RADIO ONLY")])
        self.combobox1.set_model(self.liststore)
        #######
        
        ###liststore del combobox2
        self.liststore2 = gtk.ListStore(str)
        self.cell2 = gtk.CellRendererText()
        self.combobox2.pack_start(self.cell2)
        self.combobox2.set_attributes(self.cell2, text=0)
        
        for i in nationlist:
			self.liststore2.append([i])
        
        self.combobox2.set_model(self.liststore2)
        self.combobox2.set_active(0)
        self.combobox1.set_active(0)
        #######
        

        self.NOME_CANALE = ""
        self.TIPO_CANALE = ""
        self.NAZIONE_CANALE = ""

        home = os.path.expanduser('~')
        self.config_dir = home +'/.tvplayer'

        self.window_Data.show()

    def main(self):

        gtk.main()
        
    def cambia_ordine(self,data=None):
		
        if self.combobox1.get_active()==0:
			
            ###riempie lista DATABASE
            self.model.clear()

            self.sort_DATABASE = self.lista.keys()
            self.sort_DATABASE.sort()
            for i in self.sort_DATABASE :
                tmp = i.split('#')
                if self.combobox2.get_active()==0:
				    self.model.append ([tmp[0],tmp[1].upper(),tmp[2],self.lista[i]])
                elif tmp[2]==self.combobox2.get_active_text():
                    self.model.append ([tmp[0],tmp[1].upper(),tmp[2],self.lista[i]])
	    	###
	    	
        if self.combobox1.get_active()==1:
			
	    	###riempie lista DATABASE solo tv
            self.model.clear()

            self.sort_DATABASE = self.lista.keys()
            self.sort_DATABASE.sort()
            for i in self.sort_DATABASE :
                tmp = i.split('#')
                if tmp[1][:-1]=="tv":
                    if self.combobox2.get_active()==0:
				        self.model.append ([tmp[0],tmp[1].upper(),tmp[2],self.lista[i]])
                    elif tmp[2]==self.combobox2.get_active_text():
                        self.model.append ([tmp[0],tmp[1].upper(),tmp[2],self.lista[i]])
	    	###
	    	
        if self.combobox1.get_active()==2:
			
	    	###riempie lista DATABASE solo radio
            self.model.clear()

            self.sort_DATABASE = self.lista.keys()
            self.sort_DATABASE.sort()
            for i in self.sort_DATABASE :
                tmp = i.split('#')
                if tmp[1][:-1]=="radio":
                    if self.combobox2.get_active()==0:
				        self.model.append ([tmp[0],tmp[1].upper(),tmp[2],self.lista[i]])
                    elif tmp[2]==self.combobox2.get_active_text():
                        self.model.append ([tmp[0],tmp[1].upper(),tmp[2],self.lista[i]])
	    	###

    def aggiungi(self,entry_link,data=None,data2=None):
        (model,iter) = self.treeselection.get_selected_rows()
        for rowpath in iter:
            iterator = model.get_iter(path=rowpath)
            self.NOME_CANALE = model.get_value(iterator,0)
            self.TIPO_CANALE = model.get_value(iterator,1)[:-1]
            self.NAZIONE_CANALE = model.get_value(iterator,2)
            url = model.get_value(iterator,3)
           # print val1,val2,val3,val4
                
            if self.TIPO_CANALE == 'TV':
                file=open(self.config_dir + '/personal_tv.list', 'a')
                file.write(self.NOME_CANALE+" #"+url+" #"+self.NAZIONE_CANALE+"\n")
                file.close
                self.window_Data.hide()
                gtk.main_quit()

            if self.TIPO_CANALE == 'RADIO':
                file=open(self.config_dir + '/personal_radio.list', 'a')
                file.write(self.NOME_CANALE+" #"+url+" #"+self.NAZIONE_CANALE+"\n")
                file.close()
                self.window_Data.hide()
                gtk.main_quit()
    

    def annulla(self,window_Data):
        self.window_Data.hide()
        gtk.main_quit()

class InviaDatabase() :

    def __init__(self,nationlist):
        builder = gtk.Builder()
        builder.set_translation_domain('tvplayer')
        builder.add_from_file("ui/InviaDatabase-ui.xml") 
        builder.connect_signals(self)
        self.window_invia = builder.get_object("window_invia")
        self.link_entry = builder.get_object("link_entry")
        self.nome_entry = builder.get_object("nome_entry")
        self.annulla_button = builder.get_object("annulla_button")
        self.invia_button = builder.get_object("invia_button")
        self.combobox1 = builder.get_object("combobox1")
        self.combobox2 = builder.get_object("combobox2")

        home = os.path.expanduser('~')
        self.config_dir = home +'/.tvplayer'
        
        ####riempie combobox1
        self.liststore = gtk.ListStore(str)
        self.cell = gtk.CellRendererText()
        self.combobox1.pack_start(self.cell)
        self.combobox1.set_attributes(self.cell, text=0)
        
        self.liststore.append([_("TV")])
        self.liststore.append([_("RADIO")])
        self.combobox1.set_model(self.liststore)
        self.combobox1.set_active(0)
        ######
        
        ####riempie combobox2
        self.liststore2 = gtk.ListStore(str)
        self.cell2 = gtk.CellRendererText()
        self.combobox2.pack_start(self.cell2)
        self.combobox2.set_attributes(self.cell2, text=0)
        
        for i in nationlist:
			if i!="ALL":
			    self.liststore2.append([i])
        
        self.combobox2.set_model(self.liststore2)
        self.combobox2.set_active(0)
        ######
        
        self.window_invia.show()

    def invia(self,nome_entry):
        nome = self.nome_entry.get_text()
        link = self.link_entry.get_text()
        nation = self.combobox2.get_active_text()
        if self.combobox1.get_active()==0:
            type = "tv"
        else:
            type = "radio"
        if link=="" or nome=="" :
            print _("Insert name and link")
        else :
            print nome
            print link
            print type
            phpdata = urllib.urlopen("http://tvplayersite.altervista.org/index.php?page=channels&name="+nome+"&url="+link+"&type="+type+"&language="+nation)
            phpdata.close()
            self.window_invia.hide()
            gtk.main_quit()

    def annulla(self,window_add):
        self.window_invia.hide()
        gtk.main_quit()
 
    def main(self):
        gtk.main()

