#!/usr/bin/python
# -*- coding: utf-8 -*-

#Copyright 2009 tv-player team <tvplayer.staff@gmail.com>
#       
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU Lesser General Public License as published by
#the Free Software Foundation; version 3 of the License.
#       
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU Lesser General Public License for more details.
#       
#You should have received a copy of the GNU Lesser General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#MA 02110-1301, USA.

import gtk, gobject
import pygtk
import sys
import os

import pygst
pygst.require("0.10")
import gst

import urllib
import string

from libradiotv.webfetch import ListGenerator
from libradiotv.player import Player
from libradiotv.player import PlayerThread
from libradiotv.add import Add
from libradiotv.add import AddDatabase
from libradiotv.add import InviaDatabase
from libradiotv.threadXML import ThreadXML
from libradiotv.threadXML import ThreadXML_la7
from libradiotv.threadXML import ThreadXML_la7Cult
from libradiotv.threadXML import Thread_youtube
from libradiotv.tele import televideo
from libradiotv.dialog import Dialog_aggiornamenti
from libradiotv.dialog import Dialog_about
from libradiotv.dialog import Dialog_preferenze
from libradiotv.dialog import Dialog_Saveflv
from libradiotv.dialog import Dialog_SaveRec
from libmimms.core import Thread_mimms

import time

import gettext
import locale


locale.setlocale(locale.LC_ALL,'')

gettext.bindtextdomain("tvplayer", '/usr/share/locale')
gettext.textdomain("tvplayer")
	
_ = gettext.gettext

class Tele:
    def __init__(self):
        self.home = os.path.expanduser('~')
        self.pag_you=1
        self.fullscrn=0
        self.hboxvisible=1
        self.la7playing=0
        self.thmimms=''
		
        self.versione="1.0.5"
        
        self.nationfile = urllib.urlopen("http://tvplayersite.altervista.org/online/languages.list")
        self.nationlist=[]
        for i in self.nationfile.readlines():
            self.nationlist.append(i[:-1])
        self.nationfile.close()

        self.listgen = ListGenerator()
        
        if not self.listgen.is_updated() :
            print _("Channel's list not present! I will download an updated list from the server.")
            self.listgen.download()

        self.PLAYER=self.listgen.default_player()
        print _("Player:")+self.PLAYER[0]


        builder = gtk.Builder()
        builder.set_translation_domain('tvplayer')
        builder.add_from_file("ui/ui.xml") 
        builder.connect_signals(self)
        self.window1 = builder.get_object("window1")
        self.edit_dialog = builder.get_object("edit_dialog")
        self.entry_edit = builder.get_object("entry_edit")
        self.menubar1 = builder.get_object("menubar1")
        self.notebook1 = builder.get_object("notebook1")
        self.vbox5 = builder.get_object("vbox5")
        if self.PLAYER[2]=='False':
            self.vbox5.hide()
        self.vbox2 = builder.get_object("vbox2")
        if self.PLAYER[3]=='False':
            self.vbox2.hide()
        self.treeview1 = builder.get_object("treeview1")
        self.treeview5 = builder.get_object("treeview5")
        self.treeview6 = builder.get_object("treeview6") 
        self.page_label = builder.get_object("page_label")
        
        self.scrolledwindow5 = builder.get_object("scrolledwindow5") 
        self.scrolledwindow7 = builder.get_object("scrolledwindow7")
        self.combobox1 = builder.get_object("combobox1")
        self.combobox2 = builder.get_object("combobox2")
        self.combobox3 = builder.get_object("combobox3")
        self.toolbar = builder.get_object("toolbar")
        self.progressbar = builder.get_object("progressbar")
        self.progressbar1 = builder.get_object("progressbar1")
        self.progressbar2 = builder.get_object("progressbar2")
        self.progressbar.hide()
        self.progressbar1.hide()
        self.progressbar2.hide()

        
        ##YOUTUBE
        self.entry_search = builder.get_object("entry_search")
        self.treeview3 = builder.get_object("treeview3")
        self.search_butt = builder.get_object("search_butt")
        self.prev_butt = builder.get_object("prev_butt")
        self.next_butt = builder.get_object("next_butt")
        self.downyou_button = builder.get_object("downyou_button")
        self.rec_button = builder.get_object("rec_button")
        self.rec_button.props.sensitive = False
        self.downyou_button.hide()
        self.downyou_button.props.sensitive = False
        
        self.prev_butt.props.sensitive = False
        self.next_butt.props.sensitive = False
        
        ##player        
        self.movie_window = builder.get_object("drawingarea1")
        self.movie_window.modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color())
        
        self.hbox7 = builder.get_object("hbox7")
        self.vbox6 = builder.get_object("vbox6")
        self.vbox6.hide()
        self.play_button = builder.get_object("play_button")
        self.stop_button = builder.get_object("stop_button")
        self.full_button = builder.get_object("full_button")
        self.unfull_button = builder.get_object("unfull_button")
        self.unfull_button.hide()
        
        self.adjustment = gtk.Adjustment(value=100, lower=0, upper=100, step_incr=1, page_incr=3)
        self.volumebutton = builder.get_object("volumebutton")
        self.volumebutton.set_adjustment(self.adjustment)
        
        self.volumeico=gtk.Image()
        self.volumeico.set_from_file("pixmaps/volume_ico/audio-volume-high.png")
        self.volumebutton.set_image(self.volumeico)

                
        self.stop_button.hide()
        
        ######gst playbin
        self.gstplayer = gst.element_factory_make("playbin", "player")
        bus = self.gstplayer.get_bus()
        bus.add_signal_watch()
        bus.enable_sync_message_emission()
        bus.connect("message", self.on_message)
        bus.connect("sync-message::element", self.on_sync_message)

        
               
        self.gst_is_playing=False
        ####

        self.menu_popup = builder.get_object("menu_popup")
        self.menu_popup1 = builder.get_object("menu_popup1")
        self.statusbar = builder.get_object("statusbar")

        self.statusbar.push(1,_("Welcome to Tv-Player"))


        if (self.PLAYER[0]=="vlc"):
        #    self.vlc_item.set_active(True)
            self.player = Player()
        elif (self.PLAYER[0]=="totem"):
         #   self.totem_item.set_active(True)
            self.player = Player("totem")
        elif (self.PLAYER[0]=="mplayer"):
         #   self.mplayer_item.set_active(True)
            self.player = Player("mplayer")
        elif (self.PLAYER[0]=="integrato"):
         #   self.integrato_item.set_active(True)
            self.player = Player("integrato")
            self.vbox6.show()
        else:
         #   self.personal_item.set_active(True)
            self.player = Player(self.PLAYER[0])



		###treeview Personal
        self.model1 = gtk.ListStore(str,str,str) 
        self.treeview1.set_model(self.model1)
        self.treeview1.set_reorderable(True)

        self.treecol1 = gtk.TreeViewColumn(_("List"))
        self.cellrenderer1 = gtk.CellRendererText()
        self.treecol1.pack_start(self.cellrenderer1, False)
        self.treecol1.set_attributes(self.cellrenderer1, text = 0)
        self.treeview1.append_column(self.treecol1)
        
        self.treeselection = self.treeview1.get_selection()
        self.treeselection.set_mode(gtk.SELECTION_MULTIPLE)
		###
		
		###treeview La7 XML

        self.model5 = gtk.ListStore(gtk.gdk.Pixbuf,str,str) 
        self.treeview5.set_model(self.model5)
                
        self.treecol5 = gtk.TreeViewColumn(_("Program"))
        self.cellrenderer5 = gtk.CellRendererPixbuf()
        self.treecol5.pack_start(self.cellrenderer5, False)
        self.treecol5.set_attributes(self.cellrenderer5, pixbuf=0)
        self.treeview5.append_column(self.treecol5)

        self.treecol6 = gtk.TreeViewColumn(_("List"))
        self.cellrenderer6 = gtk.CellRendererText()
        self.treecol6.pack_start(self.cellrenderer6, False)
        self.treecol6.set_attributes(self.cellrenderer6, markup=1)
        self.treeview5.append_column(self.treecol6)
		###
		
		###treeview TG REGIONALI
        self.model6 = gtk.ListStore(str,str) 
        self.treeview6.set_model(self.model6)

        self.treecol7 = gtk.TreeViewColumn(_("List"))
        self.cellrenderer7 = gtk.CellRendererText()
        self.treecol7.pack_start(self.cellrenderer7, False)
        self.treecol7.set_attributes(self.cellrenderer7, markup = 0)
        self.treeview6.append_column(self.treecol7)
		###
		
		###treeview YOUTUBE

        self.model8 = gtk.ListStore(gtk.gdk.Pixbuf,str,str) 
        self.treeview3.set_model(self.model8)
                
        self.treecol8 = gtk.TreeViewColumn(_("List"))
        self.cellrenderer8 = gtk.CellRendererPixbuf()
        self.treecol8.pack_start(self.cellrenderer8, False)
        self.treecol8.set_attributes(self.cellrenderer8, pixbuf=0)

        self.cellrenderer9 = gtk.CellRendererText()
        self.treecol8.pack_start(self.cellrenderer9, False)
        self.treecol8.set_attributes(self.cellrenderer9, markup=1)
        self.treeview3.append_column(self.treecol8)
		###
		
		
		###liststore combobox1 REGISTRAZIONI
        self.liststore = gtk.ListStore(str)
        self.cell = gtk.CellRendererText()
        self.combobox1.pack_start(self.cell)
        self.combobox1.set_attributes(self.cell, text=0)
        
        self.liststore.append([_("Rai's Recordings")])
        self.liststore.append([_("La7: The Week")])
        self.liststore.append([_("La7: Cult Archive")])
        self.liststore.append([_("TG")])
        self.combobox1.set_model(self.liststore)
        self.combobox1.set_active(0)
		###
		
		###liststore combobox2 TV/RADIO
        self.liststore2 = gtk.ListStore(str)
        self.cell2 = gtk.CellRendererText()
        self.combobox2.pack_start(self.cell2)
        self.combobox2.set_attributes(self.cell2, text=0)
        
        self.liststore2.append([_("TV")])
        self.liststore2.append([_("RADIO")])
        self.combobox2.set_model(self.liststore2)
		###
		
		###liststore combobox3 NATION
        self.liststore3 = gtk.ListStore(str)
        self.cell3 = gtk.CellRendererText()
        self.combobox3.pack_start(self.cell3)
        self.combobox3.set_attributes(self.cell3, text=0)
        
        for i in self.nationlist:
			self.liststore3.append([i])

        self.combobox3.set_model(self.liststore3)
        self.combobox2.set_active(0)
        self.combobox3.set_active(int(self.PLAYER[4]))
		###

        gtk.gdk.threads_init()
        
        self.window1.show()
        
       
    def comboTV_RADIO_change(self,data=None):
		###riempie lista TV/RADIO
        self.model1.clear()
       # print self.combobox3.get_active_text()

        if self.combobox2.get_active()==0:
            self.type = "tv"
        else:
            self.type = "radio"
        self.WEB_PERSONAL = self.listgen.generatePersonalList(self.type)
        for i in self.WEB_PERSONAL :
            tmp=i.split('#')
            if self.combobox3.get_active()==0:
				self.model1.append ([tmp[0],tmp[1],tmp[2]])
            elif tmp[2]==self.combobox3.get_active_text():
				self.model1.append ([tmp[0],tmp[1],tmp[2]])
		###

    def comboREGISTRAZIONI_change(self,data=None):
	     	
        if (self.combobox1.get_active()==0):
            print _("Rai's Recordings")  
            self.treeview5.hide()
            self.treeview6.show()
            self.scrolledwindow5.hide()
            self.scrolledwindow7.show()
	    	###scarica e riempie lista RAIXML
            self.model6.clear()
            self.model6.append([_("Downloading the list..."),""])

            th = ThreadXML(self.model6,self.statusbar,self.combobox1)
            th.start()
		    ###
	     	
        if (self.combobox1.get_active()==1):
            print _("La7: The Week")
            self.scrolledwindow7.hide()
            self.scrolledwindow5.show()
            self.treeview5.show()
            self.treeview6.hide()
	        ###scarica e riempie lista LA7 La settimana
            self.model5.clear()
         #   gtk.gdk.threads_init()

            th = ThreadXML_la7(self.model5,self.statusbar,self.combobox1)
            th.start()
		    ###
		    
        if (self.combobox1.get_active()==2):
            print _("La7: Cult Archive")
            self.scrolledwindow7.hide()
            self.scrolledwindow5.show()
            self.treeview5.show()
            self.treeview6.hide()
	        ###scarica e riempie lista LA7 Archivio cult
            self.model5.clear()
         #   gtk.gdk.threads_init()

            th = ThreadXML_la7Cult(self.model5,self.statusbar,self.combobox1)
            th.start()
		    ###
   
        if (self.combobox1.get_active()==3):
            print _("Regional TG") 
		    ###riempie lista TG REGIONALI
            self.treeview5.hide()
            self.treeview6.show()
            self.scrolledwindow5.hide()
            self.scrolledwindow7.show()
            self.model6.clear()

            self.model6.append (['Ultimo Tg1','http://link.rai.it/x/vod/ue/wmx/ultimo_tg1.asx'])
            self.model6.append (['Ultimo Tg2','http://link.rai.it/x/vod/ue/wmx/ultimo_tg2.asx'])
            self.model6.append (['Ultimo Tg3','http://link.rai.it/x/vod/ue/wmx/ultimo_tg3.asx'])

            self.TGR = self.listgen.generateTGRList()
            self.sort_TGR = self.TGR.keys()
            self.sort_TGR.sort()
            for i in self.sort_TGR :
               self.model6.append ([i,self.TGR[i]])
	     	###


    def play(self,treeview1,data=None,data1=None):
		###play canale
        self.player = Player(self.PLAYER[0])
        if self.notebook1.get_current_page() == 0:
			(model,iter) = self.treeselection.get_selected_rows()
			try:
				iterator = model.get_iter(path=iter[0])
			except:
				print _("You have to choose a channel")
				self.statusbar.push(1,_("You have to choose a channel"))
				return
			canale = model.get_value(iterator, 0)
			url = model.get_value(iterator, 1)
			print url
			print self.PLAYER[0]
			self.statusbar.push(1,_("Channel: ")+canale)
			if canale[:3]=="Rai":
				url = self.listgen.get_rai_link(url)
			if self.PLAYER[0]=='integrato':
				self.progressbar.show()
				self.progressbar.set_text("Buffering 0%")
				self.progressbar.set_fraction(0.0)
				a=url.replace('http','mms')
				url=a
				self.player.play(url, self.play_button, self.stop_button, self.gstplayer, self.gst_is_playing)
				self.gst_is_playing=True
			else:
				self.player.play(url, None, None, None, None)

        if self.notebook1.get_current_page() == 1 and self.combobox1.get_active()==0:
			##self.player = Player("mplayerRAI")
			self.treeselection6 = self.treeview6.get_selection()
			(model6,iter6) = self.treeselection6.get_selected()
			url = model6.get_value(iter6, 1)
			print url
			self.statusbar.push(1,_("Rai's recordings"))
			if self.PLAYER[0]=='mplayer':
				self.player = Player("mplayerRAI")
			if self.PLAYER[0]=='totem':
				url = self.listgen.get_rairec_link(url)
				self.player.play(url, None, None, None, None)
			if self.PLAYER[0]=='integrato':
				self.progressbar.show()
				self.progressbar.set_text("Buffering 0%")
				self.progressbar.set_fraction(0.0)
				url = self.listgen.get_rairec_link(url)
				url2 = url.replace('http','mms')
				self.player.play(url2, self.play_button, self.stop_button, self.gstplayer, self.gst_is_playing)
				self.gst_is_playing=True
			else:
				self.player.play(url, None, None, None, None)
			
        if self.notebook1.get_current_page() == 1 and (self.combobox1.get_active()==1 or self.combobox1.get_active()==2):
			self.treeselection5 = self.treeview5.get_selection()
			(model5,iter5) = self.treeselection5.get_selected()
			url = model5.get_value(iter5, 2)
			print url
			self.statusbar.push(1,_("La7 Recordings"))
			if self.PLAYER[0]=='integrato':
				self.progressbar.show()
				os.system("flvstreamer -r "+url+" > $HOME/.tvplayer/LA7.mp4 &")
				th=PlayerThread('file:///'+self.home+'/.tvplayer/LA7.mp4',self.play_button, self.stop_button, self.gstplayer, self.gst_is_playing,self.statusbar,self.progressbar)
				th.run()
				self.la7playing=1
				self.gst_is_playing=True
			else:
				os.system("./la7.sh "+self.PLAYER[0]+" "+url+" &")
			
			
        if self.notebook1.get_current_page() == 1 and self.combobox1.get_active()==3:
			self.treeselectionTG = self.treeview6.get_selection()
			(modelTG,iterTG) = self.treeselectionTG.get_selected()
			tg=modelTG.get_value(iterTG, 0)
			regione = modelTG.get_value(iterTG, 1)
			if tg[:6]=='Ultimo':
				webfile = urllib.urlopen(regione)
				asx=webfile.readlines()
				url=asx[6].split('"')[1]
				self.statusbar.push(1,"TG: "+modelTG.get_value(iterTG, 0))
				if self.PLAYER[0]=='integrato':
					self.progressbar.show()
					self.progressbar.set_text("Buffering 0%")
					self.progressbar.set_fraction(0.0)
					self.player.play(ramread, self.play_button, self.stop_button, self.gstplayer, self.gst_is_playing)
					self.gst_is_playing=True
				else:
					self.player.play(url, None, None, None, None)
			else:
				webfile = urllib.urlopen("http://www.tgr.rai.it/SITOTG/TGR_popupvideo/1,8506,tgr^puglia,00.html")
				web=webfile.read()
				webfile.close()
				media=web[string.find(web, regione+"tgr"):-1].split("'")
				url="http://www.inforegioni.rai.it/ram/regioni/"+regione+"/tgr/"+media[1]
				print url
				self.statusbar.push(1,_("Regional's TG: ")+modelTG.get_value(iterTG, 0))
				if self.PLAYER[0]=='integrato':
					ram=urllib.urlopen(url)
					ramread=ram.read()
					ram.close()
					self.progressbar.show()
					self.progressbar.set_text("Buffering 0%")
					self.progressbar.set_fraction(0.0)
					self.player.play(ramread, self.play_button, self.stop_button, self.gstplayer, self.gst_is_playing)
					self.gst_is_playing=True
				else:
					self.player.play(url, None, None, None, None)

    def exit(self,window1):
        if self.la7playing==1:
            os.system("kill -15 `pidof flvstreamer` && rm -rf $HOME/.tvplayer/LA7.mp4")
            self.la7playing=0
        sys.exit()

    def show_about(self,dialog1) :
        ###Mostra la finestra "InformazioniSu..."
        self.aboutdialog=Dialog_about()
        self.aboutdialog.main()
      
    def controlla_versione(self,data=None):
        self.controlla_aggiornamenti=Dialog_aggiornamenti(self.versione)
        self.controlla_aggiornamenti.main()
			
        
    def aggiungi(self,window1) :
        add = Add(self.nationlist)
        add.main()
        self.comboTV_RADIO_change()

    def cancella_buttclick(self,model1) :
		if self.combobox2.get_active()==0:
			self.type = "tv"
		else:
			self.type = "radio"
			
		(model,iter) = self.treeselection.get_selected_rows()
		if iter:
			for rowpath in iter:
				iterator = model.get_iter(path=rowpath)
				link_canale = model.get_value(iterator,1)
				print _("Delete:")+link_canale
				if len(iter)==1:
					self.statusbar.push(1, _("Channel deleted: ")+model.get_value(iterator, 0))
				else:
					self.statusbar.push(1, str(len(iter))+_(" Channels deleted"))
				self.listgen.removeitemPersonalList(link_canale,self.type)
			self.comboTV_RADIO_change()
		else:
			print _("You have to choose a channel")
			self.statusbar.push(1, _("You have to choose a channel"))

    def add_datatab(self,window1) :
        self.listgen.download_DATABASE()
        lista = self.listgen.generateDatabaseList()
        add = AddDatabase(lista,self.nationlist)
        add.main()
        self.comboTV_RADIO_change()

    def invia_linkData(self,window1) :
        invia = InviaDatabase(self.nationlist)
        invia.main()

    def menu_popup_show(self,menu_popup,event):
		if event.type == gtk.gdk.BUTTON_PRESS and event.button == 3:
			self.menu_popup.popup(None, None, None, event.button, event.time)
		if event.type == gtk.gdk.KEY_PRESS and event.keyval == 65535:
			self.cancella_buttclick(None)
			
    def televideo(self,data=None) :
        tele = televideo()
        tele.main()
        
#########
    def on_message(self, bus, message):
        t = message.type
        if t == gst.MESSAGE_BUFFERING:
			percent = message.parse_buffering()
			gtk.gdk.threads_enter()
			self.progressbar.set_text("Buffering "+str(percent)+"%")
			self.progressbar.set_fraction(percent/100)
			if percent==100:
				self.progressbar.hide()
			gtk.gdk.threads_leave()
        if t == gst.MESSAGE_EOS:
            self.gstplayer.set_state(gst.STATE_NULL)
            self.play_button.show()
            self.stop_button.hide()
        elif t == gst.MESSAGE_ERROR:
            self.gstplayer.set_state(gst.STATE_NULL)
            err, debug = message.parse_error()
            print "Error: %s" % err, debug
            self.statusbar.push(1, "Error: "+str(err))
            self.gst_is_playing=False
            self.play_button.show()
            self.stop_button.hide()
            self.progressbar.hide()
	
    def on_sync_message(self, bus, message):
        if message.structure is None:
            return
        if message.structure.get_name() == 'prepare-xwindow-id':
			# Sync with the X server before giving the X-id to the sink
            gtk.gdk.threads_enter()
            gtk.gdk.display_get_default().sync()
            imagesink = message.src
            imagesink.set_property("force-aspect-ratio", True)
            imagesink.set_xwindow_id(self.movie_window.window.xid)
            gtk.gdk.threads_leave()
       
    def play_butt(self, data):
        self.play(None,None,None)
        self.gst_is_playing=True
        
    def stop_butt(self, data):
        self.progressbar.hide()
        self.gstplayer.set_state(gst.STATE_NULL)
        self.gst_is_playing=False
        if self.la7playing==1:
			os.system("kill -15 `pidof flvstreamer` && rm -rf $HOME/.tvplayer/LA7.mp4")
			self.la7playing=0
        self.play_button.show()
        self.stop_button.hide()
        
       # self.button.set_label("Start")
    def set_volume(self,data,nuovo_volume):
        current_volume = self.gstplayer.get_property("volume")
      #  print current_volume
        
        if nuovo_volume==0:
            self.volumeico.set_from_file("pixmaps/volume_ico/audio-volume-muted.png")
            self.volumebutton.set_image(self.volumeico)
        if nuovo_volume>0:
            self.volumeico.set_from_file("pixmaps/volume_ico/audio-volume-low.png")
            self.volumebutton.set_image(self.volumeico)
        if nuovo_volume>40:
            self.volumeico.set_from_file("pixmaps/volume_ico/audio-volume-medium.png")
            self.volumebutton.set_image(self.volumeico)
        if nuovo_volume>70:
            self.volumeico.set_from_file("pixmaps/volume_ico/audio-volume-high.png")
            self.volumebutton.set_image(self.volumeico)
     #   print nuovo_volume
        self.gstplayer.set_property("volume", nuovo_volume/100)

##########ssssssssssssss

##YOUTUBE
    def youtube_search(self,data=None):
        self.pag_you=1
       # self.search_butt.props.sensitive = False
        self.page_label.set_text(_('Page 1'))
        search_text=self.entry_search.get_text()
        th=Thread_youtube(self.model8,None,search_text,str('1'),self.search_butt,self.prev_butt,self.next_butt)
        th.start()
        
    def youtube_search_next(self,data=None):
        self.pag_you+=1
        self.page_label.set_text(_('Page ')+str(self.pag_you))
        search_text=self.entry_search.get_text()
        th=Thread_youtube(self.model8,None,search_text,str(self.pag_you*25),self.search_butt,self.prev_butt,self.next_butt)
        th.start()
        
    def youtube_search_previous(self,data=None):
        self.pag_you-=1
        print self.pag_you
        self.page_label.set_text(_('Page ')+str(self.pag_you))
        search_text=self.entry_search.get_text()
        if self.pag_you==1:
            th=Thread_youtube(self.model8,None,search_text,str(self.pag_you),self.search_butt,self.prev_butt,self.next_butt)
        else:
            th=Thread_youtube(self.model8,None,search_text,str(self.pag_you*25),self.search_butt,self.prev_butt,self.next_butt)
        th.start()
        
        
    def get_flv_link(self,data=None,data2=None,data3=None):
		self.treeselection8 = self.treeview3.get_selection()
		(model8,iter8) = self.treeselection8.get_selected()
		link=model8.get_value(iter8, 2)
		url=self.listgen.get_flv_video_url(link)
		print url
		if self.PLAYER[0]=='integrato':
			self.progressbar.show()
			self.progressbar.set_text("Buffering 0%")
			self.progressbar.set_fraction(0.0)
			self.player.play(url, self.play_button, self.stop_button, self.gstplayer, self.gst_is_playing)
			self.gst_is_playing=True
		else:
			self.player.play(url, None, None, None, None)
			
    def youtube_menu_popup(self,menu_popup,event):
		if event.type == gtk.gdk.BUTTON_PRESS and event.button == 3:
			self.menu_popup1.popup(None, None, None, event.button, event.time)
			
    def selectvideo(self,data=None):
		self.downyou_button.props.sensitive = True
		
    def select_rec_video(self,data=None):
		self.rec_button.props.sensitive = True
				
    def download_youtube(self,data=None,data2=None,data3=None):
		self.treeselection8 = self.treeview3.get_selection()
		(model8,iter8) = self.treeselection8.get_selected()
		link=model8.get_value(iter8, 2)
		url=self.listgen.get_flv_video_url(link)
		print url

		Dialog_Saveflv(url,self.progressbar1,self.statusbar)

#####
			
    def fullscreen(self,data=None):
		self.unfull_button.show()
		self.full_button.hide()
		
		self.statusbar.hide()
		self.hbox7.hide()
		self.menubar1.hide()
		self.toolbar.hide()
		self.notebook1.hide()
		self.window1.fullscreen()
		
		
		self.fullscrn=1
		self.hboxvisible=0
		
    def unfullscreen(self,data=None,event=None):
		if event.type == gtk.gdk.KEY_PRESS and event.keyval == 65307:
			self.unfull_button.hide()
			self.full_button.show()
			
			self.statusbar.show()
			self.hbox7.show()
			self.menubar1.show()
			self.toolbar.show()
			self.notebook1.show()
			self.window1.unfullscreen()
			
			self.fullscrn=0
			self.hboxvisible=1
			
    def unfull_but(self,data=None):
		self.unfull_button.hide()
		self.full_button.show()
		
		self.statusbar.show()
		self.hbox7.show()
		self.menubar1.show()
		self.toolbar.show()
		self.notebook1.show()
		self.window1.unfullscreen()
		
		self.fullscrn=0
		self.hboxvisible=1
			
    def full_buttons(self,data=None,event=None):
        if event.type == gtk.gdk.BUTTON_PRESS and event.button == 1:

			if self.fullscrn==1 and self.hboxvisible==0:
				self.hbox7.show()
				self.hboxvisible=1
			elif self.fullscrn==1 and self.hboxvisible==1:
				self.hbox7.hide()
				self.hboxvisible=0
				
        if event.type == gtk.gdk._2BUTTON_PRESS and event.button == 1:
			if self.fullscrn==1:
				self.unfull_but()
			else:
				self.fullscreen()
				
    def list_reorder(self,data=None,data2=None):
		if self.combobox2.get_active()==0:
			self.type = "tv"
		else:
			self.type = "radio"
		self.list=[]
		for row in self.model1:
			self.list.append(row[0]+"#"+row[1]+"#"+row[2])
		self.listgen.reorderPersonalList(self.list,self.type,self.combobox3.get_active_text())
		
    def preferenze(self,data=None):
        ###Mostra la finestra "Preferenze"
        self.preferenzedialog=Dialog_preferenze(self.PLAYER,self.vbox6,self.statusbar,self.listgen,self.vbox5,self.vbox2,self.nationlist,self.combobox3,self.window1)
        self.preferenzedialog.main()
        
    def recordings_hide(self,data=None):
        self.PLAYER[2]='False'
        self.vbox5.hide()
        self.listgen.write_player_config(self.PLAYER[0],self.PLAYER[1],self.PLAYER[2],self.PLAYER[3],self.PLAYER[4])
        
    def youtube_hide(self,data=None):
        self.PLAYER[3]='False'
        self.vbox2.hide()
        self.listgen.write_player_config(self.PLAYER[0],self.PLAYER[1],self.PLAYER[2],self.PLAYER[3],self.PLAYER[4])
        
        
    def registra(self,button=None):
		if button.get_active()==True:
			(model,iter) = self.treeselection.get_selected_rows()
			try:
				iterator = model.get_iter(path=iter[0])
			except:
				print _("You have to choose a channel")
				self.statusbar.push(1,_("You have to choose a channel"))
				return
			canale = model.get_value(iterator, 0)
			url = model.get_value(iterator, 1)
			if canale[:3]=="Rai":
				url = self.listgen.get_rai_link(url)
				url = url.replace('http','mms')
			if url[:3]=='mms':
				self.rec=Dialog_SaveRec(url,self.progressbar2,self.statusbar,self.rec_button)
		else:
			self.rec.stop_thread()
			
    def switch_page(self,data=None,page=None,page_num=None):
		if page_num == 0:
			self.downyou_button.hide()
			self.rec_button.show()
		if page_num == 1:
			self.downyou_button.hide()
			self.rec_button.hide()
		if page_num == 2:
			self.downyou_button.show()
			self.rec_button.hide()
			
#######EDIT NAME
    def show_edit(self,data=None):
        (model,iter) = self.treeselection.get_selected_rows()
        try:
            iterator = model.get_iter(path=iter[0])
        except:
            print _("You have to choose a channel")
            self.statusbar.push(1,_("You have to choose a channel"))
            return
        self.entry_edit.set_text(model[iterator][0])
        self.edit_dialog.show()
		
    def name_edit(self,data=None):
        new_name = self.entry_edit.get_text()
        print new_name
        (model,iter) = self.treeselection.get_selected_rows()
        try:
            iterator = model.get_iter(path=iter[0])
        except:
            print _("You have to choose a channel")
            self.statusbar.push(1,_("You have to choose a channel"))
            return
        model[iterator][0] = new_name
        self.list_reorder(None,None)
        self.close_edit()

    def close_edit(self,data=None):
		self.edit_dialog.hide()
#######

    def main(self):
		

        gtk.main()


if __name__ == "__main__":
    tele = Tele()
    tele.main()
